#include <ESP8266WiFi.h>
#include <ArduinoJson.h>
#include <WiFiClientSecure.h>

#define TOKEN "c067ae0de0ab70a8dee50e2a224ea4faeb9a45b1b1e30352bbe5b58865b2fc19-"	//替换自己的钉钉群token

#define WIFI_SSID        "PENGBO"          //替换自己的WIFI
#define WIFI_PASSWD      "201314201314201314-"    //替换自己的WIFI

WiFiClientSecure client;

void init_wifi(const char *ssid, const char *password)
{
    WiFi.mode(WIFI_STA);
    WiFi.begin(ssid, password);
    while (WiFi.status() != WL_CONNECTED)
    {
        Serial.println("WiFi does not connect, try again ...");
        delay(500);
    }
}

String gen_data(String msg)
{
	StaticJsonDocument<1024>  jsonBuffer;

	jsonBuffer["msgtype"] = "text";
	JsonObject text = jsonBuffer.createNestedObject("text");
	text["content"]=msg;
	String output;
	serializeJson(jsonBuffer, output);
	return output;
}

void send2dingtalk(String msg)
{
	char host[] = "oapi.dingtalk.com";
	if (client.connect(host, 443)) {
		Serial.println("connected");
		String url = "/robot/send?access_token=" TOKEN;
		//String data = gen_data("温度:30,这是一条测试消息。\n          --来自esp8266");
		String data = gen_data(msg);
		//Serial.println(data.length());

		//String postRequest = "POST " + url + " HTTP/1.1\r\n" + "Host: " + host + "\r\n" + "Content-Type: application/json\r\n" + "Transfer-encoding: Chunked\r\n" + "Content-Length: " + data.length() + "\r\n" + "\r\n" + data;
		String postRequest = "POST " + url + " HTTP/1.1\r\n" + "Host: " + host + "\r\n" + "Content-Type: application/json\r\n" + "Content-Length: " + data.length() + "\r\n" + "\r\n" + data;
		//String postRequest = "POST " + url + " HTTP/1.1\r\n" + "Host: " + host + "\r\n" + "Content-Type: application/json\r\n" + "Transfer-encoding: Chunked\r\n" + "\r\n" + data;
		client.println(postRequest);
		Serial.println(postRequest);

	}
	client.stop();
}

void setup()
{
    Serial.begin(115200);

    init_wifi(WIFI_SSID, WIFI_PASSWD);
	client.setInsecure();
}

// the loop function runs over and over again forever
void loop()
{
	String rec="";
    if (Serial.available() >0)
	{
    rec="";
		delay(100);
		int len = Serial.available();
		int count=0;
		if (len > 0)
		{
			for(int i=0;i<len-2;i++)
			{
				rec+=char(Serial.read());
				delay(2);
			}
			Serial.read();
			delay(2);
			Serial.read();
			delay(2);
			send2dingtalk(rec);
		}
	}
}
